#include <pybind11/pybind11.h>

#include "Experiment.cpp"



PYBIND11_MODULE(Experiment, module)
{
  pybind11::class_<Experiment>(module, "CppExperiment")
  .def(pybind11::init<>())

  .def("SetDetector", &Experiment::SetDetector,  pybind11::arg("CppDetectorSet") )

  .def("SetSource", &Experiment::SetSource,  pybind11::arg("CppSourceSet") )

  .def("SetSphere", &Experiment::SetSphere, pybind11::arg("CppSphereSet") )

  .def("SetCylinder", &Experiment::SetCylinder, pybind11::arg("CppCylinderSet") )

  .def("SetCoreShell", &Experiment::SetCoreShell, pybind11::arg("CppCoreShellSet") )

  .def("GetSphereQsca",            &Experiment::GetSphereQsca)
  .def("GetSphereQext",            &Experiment::GetSphereQext)
  .def("GetSphereQabs",            &Experiment::GetSphereQabs)
  .def("GetSphereQabs",            &Experiment::GetSphereQabs)
  .def("GetSphereQpr",             &Experiment::GetSphereQpr)
  .def("GetSphereQforward",        &Experiment::GetSphereQforward)
  .def("GetSphereQback",           &Experiment::GetSphereQback)
  .def("GetSphereCsca",            &Experiment::GetSphereCsca)
  .def("GetSphereCext",            &Experiment::GetSphereCext)
  .def("GetSphereCabs",            &Experiment::GetSphereCabs)
  .def("GetSphereCabs",            &Experiment::GetSphereCabs)
  .def("GetSphereCpr",             &Experiment::GetSphereCpr)
  .def("GetSphereCforward",        &Experiment::GetSphereCforward)
  .def("GetSphereCback",           &Experiment::GetSphereCback)
  .def("GetSphereCoupling",        &Experiment::GetSphereCoupling)

  .def("GetSphereAn",              &Experiment::GetSphereAn)
  .def("GetSphereBn",              &Experiment::GetSphereBn)
  .def("GetSphereA1",              &Experiment::GetSphereA1)
  .def("GetSphereB1",              &Experiment::GetSphereB1)
  .def("GetSphereA2",              &Experiment::GetSphereA2)
  .def("GetSphereB2",              &Experiment::GetSphereB2)


  .def("GetCylinderQsca",          &Experiment::GetCylinderQsca)
  .def("GetCylinderQext",          &Experiment::GetCylinderQext)
  .def("GetCylinderQabs",          &Experiment::GetCylinderQabs)
  .def("GetCylinderQabs",          &Experiment::GetCylinderQabs)
  .def("GetCylinderQpr",           &Experiment::GetCylinderQpr)
  .def("GetCylinderQforward",      &Experiment::GetCylinderQforward)
  .def("GetCylinderQback",         &Experiment::GetCylinderQback)
  .def("GetCylinderCsca",          &Experiment::GetCylinderCsca)
  .def("GetCylinderCext",          &Experiment::GetCylinderCext)
  .def("GetCylinderCabs",          &Experiment::GetCylinderCabs)
  .def("GetCylinderCabs",          &Experiment::GetCylinderCabs)
  .def("GetCylinderCpr",           &Experiment::GetCylinderCpr)
  .def("GetCylinderCforward",      &Experiment::GetCylinderCforward)
  .def("GetCylinderCback",         &Experiment::GetCylinderCback)
  .def("GetCylinderCoupling",      &Experiment::GetCylinderCoupling)

  .def("GetCylinderA1n",           &Experiment::GetCylinderA1n)
  .def("GetCylinderA2n",           &Experiment::GetCylinderA2n)
  .def("GetCylinderB1n",           &Experiment::GetCylinderB1n)
  .def("GetCylinderB2n",           &Experiment::GetCylinderB2n)
  .def("GetCylinderA11",           &Experiment::GetCylinderA11)
  .def("GetCylinderA21",           &Experiment::GetCylinderA21)
  .def("GetCylinderB11",           &Experiment::GetCylinderB11)
  .def("GetCylinderB21",           &Experiment::GetCylinderB21)
  .def("GetCylinderA12",           &Experiment::GetCylinderA12)
  .def("GetCylinderA22",           &Experiment::GetCylinderA22)
  .def("GetCylinderB12",           &Experiment::GetCylinderB12)
  .def("GetCylinderB22",           &Experiment::GetCylinderB22)
  .def("GetCylinderA13",           &Experiment::GetCylinderA13)
  .def("GetCylinderA23",           &Experiment::GetCylinderA23)
  .def("GetCylinderB13",           &Experiment::GetCylinderB13)
  .def("GetCylinderB23",           &Experiment::GetCylinderB23)


  .def("GetCoreShellQsca",         &Experiment::GetCoreShellQsca)
  .def("GetCoreShellQext",         &Experiment::GetCoreShellQext)
  .def("GetCoreShellQabs",         &Experiment::GetCoreShellQabs)
  .def("GetCoreShellQabs",         &Experiment::GetCoreShellQabs)
  .def("GetCoreShellQpr",          &Experiment::GetCoreShellQpr)
  .def("GetCoreShellQforward",     &Experiment::GetCoreShellQforward)
  .def("GetCoreShellQback",        &Experiment::GetCoreShellQback)
  .def("GetCoreShellCsca",         &Experiment::GetCoreShellCsca)
  .def("GetCoreShellCext",         &Experiment::GetCoreShellCext)
  .def("GetCoreShellCabs",         &Experiment::GetCoreShellCabs)
  .def("GetCoreShellCabs",         &Experiment::GetCoreShellCabs)
  .def("GetCoreShellCpr",          &Experiment::GetCoreShellCpr)
  .def("GetCoreShellCforward",     &Experiment::GetCoreShellCforward)
  .def("GetCoreShellCback",        &Experiment::GetCoreShellCback)
  .def("GetCoreShellCoupling",     &Experiment::GetCoreShellCoupling)

  .def("GetCoreShellAn",           &Experiment::GetCoreShellAn)
  .def("GetCoreShellBn",           &Experiment::GetCoreShellBn)
  .def("GetCoreShellA1",           &Experiment::GetCoreShellA1)
  .def("GetCoreShellB1",           &Experiment::GetCoreShellB1)
  .def("GetCoreShellA2",           &Experiment::GetCoreShellA2)
  .def("GetCoreShellB2",           &Experiment::GetCoreShellB2)
  .def("GetCoreShellA3",           &Experiment::GetCoreShellA3)
  .def("GetCoreShellB3",           &Experiment::GetCoreShellB3)

  ;

}
