#include <pybind11/pybind11.h>

#include "FibonnaciMesh.cpp"

  PYBIND11_MODULE(Fibonacci, module) {
      module.doc() = "LGeneralized Lorenz-Mie Theory (GLMT) c++ binding module for light scattering from a spherical scatterer";

        pybind11::class_<FibonacciMesh>(module, "FIBONACCI")
        .def(pybind11::init<int, double, double, double>(),
             pybind11::arg("Sampling"),
             pybind11::arg("MaxAngle"),
             pybind11::arg("PhiOffset"),
             pybind11::arg("GammaOffset") )

        .def_property_readonly("X", &FibonacciMesh::Getx)
        .def_property_readonly("Y", &FibonacciMesh::Gety)
        .def_property_readonly("Z", &FibonacciMesh::Getz)

        .def_property_readonly("R", &FibonacciMesh::GetR)
        .def_property_readonly("Phi", &FibonacciMesh::GetPhi)
        .def_property_readonly("Theta", &FibonacciMesh::GetTheta)

        .def_readwrite("dOmega", &FibonacciMesh::dOmega)
        .def_readwrite("Omega", &FibonacciMesh::Omega)

        .def("ComputeVectorField", &FibonacciMesh::ComputeVectorField)
        .def("ComputeHVProjection", &FibonacciMesh::ComputeHVProjection)

        .def_property_readonly("ParaVector", &FibonacciMesh::GetPara)
        .def_property_readonly("PerpVector", &FibonacciMesh::GetPerp)

        .def_property_readonly("HPara", &FibonacciMesh::GetHPara)
        .def_property_readonly("HPerp", &FibonacciMesh::GetHPerp)
        .def_property_readonly("VPara", &FibonacciMesh::GetVPara)
        .def_property_readonly("VPerp", &FibonacciMesh::GetVPerp)
        ;
  }







// -
